; Inno setup for Narval on python 2.1

[Setup]
AppName=Narval
AppVerName=Narval-1.1
AppPublisher=Logilab 
AppPublisherURL=http://www.logilab.com/ 
AppVersion=1.1
DefaultDirName={pf}\Narval-1.1
DefaultGroupName=Narval-1.1
AppCopyright=Copyleft  2000-2001 Logilab
LicenseFile=license.txt
SourceDir=..\..
OutputDir=.
OutPutBaseFileName=Narval-1.1_setup

[Types]
Name:"full";Description:"Full installation. You only need Python preinstalled. Try it."
Name:"compact";Description:"Only the bare minimum Narval files."
Name:"custom";Description:"Custom installation.";Flags:iscustom

[Components]
Name: "narval" ; Description: "Narval main files"; Types: full compact custom; Flags: fixed
Name: "manuals"; Description: "Narval manuals"; Types: full custom
Name: "uml"    ; Description: "Narval UML diagrams"; Types:full custom
Name: "depend";  Description: "Required dependencies"; Types: full custom
Name: "options"; Description: "Optional extensions"; Types: full custom

[Tasks]
Name: "pyxml"  ; Description: "Install PyXML 0.6.6"; GroupDescription: "Packages needed for Narval to work:"; Components: depend; Flags: checkedonce
Name: "4Suite" ; Description: "Install 4Suite 0.11.1"; GroupDescription: "Packages needed for Narval to work:"; Components: depend; Flags: checkedonce
Name: "pygtk"  ; Description: "Install PyGTK and required DLLs"; GroupDescription: "Packages needed for Narval to work:"; Components: depend; Flags: checkedonce
Name: "xmltools";Description: "Install Python XmlTools for graphical edition of XML"; GroupDescription: "Packages needed for Narval to work:"; Components: depend; Flags: checkedonce
Name: "xmlrpc";  Description: "Install Python xmlrpc protocol implementation"; GroupDescription: "Packages needed for Narval to work:"; Components: depend; Flags: checkedonce
;Name: "xmldiff"; Description: "Install Python XmlDiff"; GroupDescription: "Optional add-on packages:"; Components: options;
Name: "vcalsax"; Description: "Install Tools to manipulate Vcal files as XML"; GroupDescription: "Optional add-on packages:"; Components: options;


[Dirs]
Name: "{app}\share"; Components: narval
Name: "{app}\share\data"; Components: narval
Name: "{app}\share\dtd";  Components: narval
Name: "{app}\share\extensions";   Components: narval
Name: "{app}\share\extensions\xmlrep";   Components: narval
Name: "{app}\share\extensions\classify";   Components: narval
Name: "{app}\share\extensions\html";   Components: narval
Name: "{app}\share\extensions\language";   Components: narval
Name: "{app}\share\modules"; Components: narval
Name: "{app}\share\recipes"; Components: narval
Name: "{app}\share\transforms\basic"; Components: narval
Name: "{app}\share\transforms\extensions";  Components: narval
Name: "{app}\share\transforms\extensions\xmlrep"; Components: narval
Name: "{app}\share\graphics"; Components: narval
Name: "{app}\tools"; Components: narval
Name: "{app}\UML"; Components: uml
Name: "{app}\manuals\modules_programmer_handbook" ; Components: manuals
Name: "{app}\manuals\narval_user_manual" ; Components: manuals
Name: "{app}\manuals\narval_technical_manual" ; Components: manuals
Name: "{app}\manuals\narval_user_manual\images"  ; Components: manuals
Name: "{app}\manuals\narval_technical_manual\images" ; Components: manuals
Name: "{app}\manuals\tutorial" ; Components: manuals
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval" ; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\en" ; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\fr" ; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\en\LC_MESSAGES" ; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\fr\LC_MESSAGES"; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\gui"; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\dom"; Components: narval
Name: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\ext" ; Components: narval

[Files]
Source: "narval\*.py";          DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval"; CopyMode:alwaysoverwrite;Components: narval
Source: "narval\en\LC_MESSAGES\*.mo"; DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\en\LC_MESSAGES"; CopyMode:alwaysoverwrite;Components: narval
Source: "narval\fr\LC_MESSAGES\*.mo"; DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\fr\LC_MESSAGES"; CopyMode:alwaysoverwrite;Components: narval
Source: "narval\dom\*.py";      DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\dom"; CopyMode:alwaysoverwrite;Components: narval
Source: "narval\ext\*.py";      DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\ext"; CopyMode:alwaysoverwrite ;Components: narval
Source: "narval\gui\*.py";      DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\gui"; CopyMode:alwaysoverwrite ;Components: narval
Source: "narval\services\*.py";      DestDir: "{reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\services"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\data\*";          DestDir: "{app}\share\data"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\dtd\*.dtd";       DestDir: "{app}\share\dtd"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\dtd\*.ent";       DestDir: "{app}\share\dtd"; CopyMode:alwaysoverwrite ;Components: narval
Source: "share\dtd\CATALOG";     DestDir: "{app}\share\dtd"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\extensions\*.py"; DestDir: "{app}\share\extensions"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\extensions\xmlrep\*.py"; DestDir: "{app}\share\extensions\xmlrep"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\extensions\html\*.py"; DestDir: "{app}\share\extensions\html"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\extensions\classify\*.py"; DestDir: "{app}\share\extensions\classify"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\extensions\language\*.py"; DestDir: "{app}\share\extensions\language"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\extensions\language\*.txt"; DestDir: "{app}\share\extensions\language"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\graphics\*.png";  DestDir: "{app}\share\graphics"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\graphics\*.xpm";  DestDir: "{app}\share\graphics"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\graphics\*.ico";  DestDir: "{app}\share\graphics"; CopyMode:alwaysoverwrite;Components: narval
Source: "share\modules\*.py";    DestDir: "{app}\share\modules"; CopyMode:alwaysoverwrite ;Components: narval
Source: "share\recipes\*.xml";   DestDir: "{app}\share\recipes"; CopyMode:alwaysoverwrite ;Components: narval
Source: "share\transforms\basic\*.xsl*"; DestDir: "{app}\share\transforms\basic";CopyMode:alwaysoverwrite ;Components: narval
Source: "share\transforms\extensions\*.py"; DestDir: "{app}\share\transforms\extensions";CopyMode:alwaysoverwrite;Components: narval
Source: "tools\*.py";            DestDir: "{app}\tools"; CopyMode:alwaysoverwrite;Components: narval
Source: "tools\pkg\*.iss";            DestDir: "{app}\tools"; CopyMode:alwaysoverwrite;Components: manuals
Source: "exec\*.bat";            DestDir: "{app}"; CopyMode:alwaysoverwrite ; Components: narval

Source: "installers\xmltools-1.3.5.win32.exe" ;      DestDir: "{tmp}"; Components: depend
;Source: "installers\xmldiff-0.5.1.win32-py2.1.exe" ; DestDir: "{tmp}"; Components: options
Source: "installers\vcalsax-0.2.win32.exe" ;         DestDir: "{tmp}"; Components: options
Source: "installers\setup.exe"  ;                    DestDir: "{tmp}"; Components: depend
Source: "installers\xmlrpc-0.9.9.010226.win32.exe" ; DestDir: "{tmp}"; Components: depend
Source: "installers\PyXML-0.6.6.win32-py2.1.exe" ;   DestDir: "{tmp}"; Components: depend
Source: "installers\4Suite-0.11.1.win32-py2.1.exe" ; DestDir: "{tmp}"; Components: depend

Source: "license.txt";          DestDir:"{app}"; CopyMode:alwaysoverwrite; Components: narval
Source: "doc\README.unix";               DestDir: "{app}"; CopyMode:alwaysoverwrite; DestName:"Readme_unix.txt"; Components: manuals
Source: "doc\README.WIN32";         DestDir: "{app}"; CopyMode:alwaysoverwrite; DestName:"Readme_windows.txt"; Components: narval
Source: "doc\CONTRIBUTORS";         DestDir: "{app}"; CopyMode:alwaysoverwrite; DestName:"Contributors.txt"; Components: narval
Source: "doc\CHANGELOG";         DestDir: "{app}"; CopyMode:alwaysoverwrite; DestName:"CHANGELOG.txt" ; Components: narval
Source: "doc\ANNOUNCE.fr";         DestDir: "{app}"; CopyMode:alwaysoverwrite; DestName:"ANNONCE.txt" ; Components: manuals
Source: "doc\ANNOUNCE.en";         DestDir: "{app}"; CopyMode:alwaysoverwrite; DestName:"ANNOUNCE.txt" ; Components: manuals
Source: "doc\UML\*.pgml";         DestDir: "{app}\UML"; CopyMode:alwaysoverwrite; Components: uml
Source: "doc\UML\*.xmi";         DestDir: "{app}\UML"; CopyMode:alwaysoverwrite;  Components: uml
Source: "doc\UML\*.argo";         DestDir: "{app}\UML"; CopyMode:alwaysoverwrite; Components: uml
Source: "doc\UML\*.ps";         DestDir: "{app}\UML"; CopyMode:alwaysoverwrite;  Components: uml
Source: "doc\UML\README";         DestDir: "{app}\UML"; CopyMode:alwaysoverwrite;DestName:"Readme.txt" ;Components: uml
Source: "doc\manuals\*.xml";         DestDir: "{app}\manuals"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\modules_programmer_handbook\*.xml";         DestDir: "{app}\manuals\modules_programmer_handbook"; CopyMode:alwaysoverwrite;Components: manuals
;Source: "doc\manuals\modules_programmer_handbook\*.pdf";         DestDir: "{app}\manuals\modules_programmer_handbook"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\modules_programmer_handbook\*.html";         DestDir: "{app}\manuals\modules_programmer_handbook"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_user_manual\*.xml";         DestDir: "{app}\manuals\narval_user_manual"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_user_manual\*.pdf";         DestDir: "{app}\manuals\narval_user_manual"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_user_manual\*.html";         DestDir: "{app}\manuals\narval_user_manual"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_user_manual\images\*.gif";         DestDir: "{app}\manuals\narval_user_manual\images"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_technical_manual\*.xml";         DestDir: "{app}\manuals\narval_technical_manual"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_technical_manual\*.pdf";         DestDir: "{app}\manuals\narval_technical_manual"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_technical_manual\*.html";         DestDir: "{app}\manuals\narval_technical_manual"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\narval_technical_manual\images\*.png";         DestDir: "{app}\manuals\narval_technical_manual\images"; CopyMode:alwaysoverwrite;Components: manuals
Source: "doc\manuals\tutorial\*.xml";         DestDir: "{app}\manuals\tutorial"; CopyMode:alwaysoverwrite; Components: manuals
Source: "doc\manuals\tutorial\*.pdf";         DestDir: "{app}\manuals\tutorial"; CopyMode:alwaysoverwrite; Components: manuals
Source: "doc\manuals\tutorial\*.html";         DestDir: "{app}\manuals\tutorial"; CopyMode:alwaysoverwrite; Components: manuals
Source: "doc\manuals\tutorial\images\*.png";         DestDir: "{app}\manuals\tutorial\images"; CopyMode:alwaysoverwrite; Components: manuals


[Icons]
Name: "{group}\Narval"; Filename: "{app}\narval.bat"; WorkingDir:"{app}"; Parameters: "--socket-manager --listen-on 8787"; IconFileName:"{app}\share\graphics\logilab.ico";
Name: "{group}\Horn";   Filename: "{app}\horn.bat";   WorkingDir:"{app}"; IconFileName:"{app}\share\graphics\logilab.ico";
Name: "{group}\documentation\README"; Filename:"{app}\Readme_windows.txt";
Name: "{group}\documentation\license.txt"; Filename:"{app}\license.txt";
Name: "{group}\documentation\html\Tutorial"; Filename:"{app}\manuals\tutorial\tutorial.html";Components: manuals
Name: "{group}\documentation\html\User Manual"; Filename:"{app}\manuals\narval_user_manual\narval_user_manual.html";Components: manuals
Name: "{group}\documentation\html\Module Programmer Handbook"; Filename:"{app}\manuals\modules_programmer_handbook\module_programmer_handbook.html";Components: manuals
Name: "{group}\documentation\html\Technical Manual"; Filename:"{app}\manuals\narval_technical_manual\narval_technical_manual.html"; Components: manuals
Name: "{group}\documentation\pdf\Tutorial"; Filename:"{app}\manuals\tutorial\tutorial.pdf"; Components: manuals
Name: "{group}\documentation\pdf\User Manual"; Filename:"{app}\manuals\narval_user_manual\narval_user_manual.pdf";Components: manuals
;Name: "{group}\documentation\pdf\Module Programmer Handbook"; Filename:"{app}\manuals\modules_programmer_handbook\module_programmer_handbook.pdf";Components: manuals
Name: "{group}\documentation\pdf\Technical Manual"; Filename:"{app}\manuals\narval_technical_manual\narval_technical_manual.pdf";Components: manuals

[Registry]
Root: HKLM; Subkey: "Software\Logilab"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Logilab\Narval"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Logilab\Narval\1.1"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Logilab\Narval\1.1\config"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Logilab\Narval\1.1\config"; ValueType: string; ValueName: "Share"; ValueData: "{app}\share" ;Flags: uninsdeletevalue createvalueifdoesntexist
Root: HKLM; Subkey: "Software\Logilab\Narval\1.1\config"; ValueType: string; ValueName: "Install"; ValueData: "{app}" ;Flags: uninsdeletevalue     createvalueifdoesntexist

[Run]
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe ; Parameters: "-c ""import sys,compileall; compileall.compile_dir(sys.argv[1])"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval"; StatusMsg:"Compiling to .pyc";Flags:runminimized
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe ; Parameters: "-Oc ""import sys,compileall; compileall.compile_dir(sys.argv[1])"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval"; StatusMsg:"Compiling to .pyo";Flags:runminimized

Filename: "{tmp}\PyXML-0.6.6.win32-py2.1.exe" ;   Tasks: pyxml   ; Components: options ;
Filename: "{tmp}\4Suite-0.11.1.win32-py2.1.exe" ; Tasks: 4Suite  ; Components: options ;
Filename: "{tmp}\setup.exe"  ;                    Tasks: pygtk   ; Components: depend    ; Parameters: "/SILENT"
Filename: "{tmp}\xmlrpc-0.9.9.010226.win32.exe" ; Tasks: xmlrpc  ; Components: depend ;
Filename: "{tmp}\xmltools-1.3.5.win32.exe" ;      Tasks: xmltools; Components: depend
;Filename: "{tmp}\xmldiff-0.5.1.win32-py2.1.exe" ; Tasks: xmldiff ; Components: depend ;
Filename: "{tmp}\vcalsax-0.2.win32.exe" ;         Tasks: vcalsax ; Components: depend ;


[UninstallRun]
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe; Parameters: "-c ""import os,sys;map(os.remove,filter(lambda f: f[-3:]=='pyc' or f[-3:] == 'pyo',os.listdir(sys.argv[1])))"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval";Flags:runminimized
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe; Parameters: "-c ""import os,sys;map(os.remove,filter(lambda f: f[-3:]=='pyc' or f[-3:] == 'pyo',os.listdir(sys.argv[1])))"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\gui";Flags:runminimized
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe; Parameters: "-c ""import os,sys;map(os.remove,filter(lambda f: f[-3:]=='pyc' or f[-3:] == 'pyo',os.listdir(sys.argv[1])))"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\services";Flags:runminimized
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe; Parameters: "-c ""import os,sys;map(os.remove,filter(lambda f: f[-3:]=='pyc' or f[-3:] == 'pyo',os.listdir(sys.argv[1])))"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\dom";Flags:runminimized
Filename: {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\python.exe; Parameters: "-c ""import os,sys;map(os.remove,filter(lambda f: f[-3:]=='pyc' or f[-3:] == 'pyo',os.listdir(sys.argv[1])))"" {reg:HKLM\Software\Python\PythonCore\2.1\InstallPath,|{app}}\narval\ext";Flags:runminimized




